# dmd.dmangle

Does name mangling for `extern(D)` symbols.

Specification: Name Mangling

#### Authors

Walter Bright, https://www.digitalmars.com

#### License

Boost License 1.0

Source: dmangle.d

Documentation: https://dlang.org/phobos/dmd_dmangle.html

Coverage: https://codecov.io/gh/dlang/dmd/src/master/src/dmd/dmangle.d

References: https://dlang.org/blog/2017/12/20/ds-newfangled-name-mangling/

- `mangleExact`

  #### Declaration

  `const(char)* `mangleExact`(FuncDeclaration `fd`);`

  Returns exact mangled name of function.

- `isValidMangling`

  #### Declaration

  `package nothrow bool `isValidMangling`(dchar `c`);`

  #### Return Value

  `true` if the given character is a valid mangled character

- `decoToType`

  #### Declaration

  `Type `decoToType`(const(char)[] `deco`);`

  Convert a string representing a type (the `deco`) and return its equivalent Type.

  #### Parameters

  `const(char)[] `deco`` | string containing the `deco`

  #### Return Value

  `null` for failed to convert Type for succeeded